# Securing Cloud-Native Systems

1.	[Securing your cloud account](./account-as-code)
2.	[Creating a federated identity pool](./cognito-pool)
3.	[Implementing sign up, sign in and sign out](./cognito-signin)
4.	[Securing an API gateway with OpenID Connect](./cognito-authorizer)
5.	[Implementing a custom authorizer](./custom-authorizer)
6.	[Authorizing a GraphQL based service](./graphql-jwt)
7.	[Implementing a JWT filter](./jwt-filter)
8.	[Using envelope encryption](./envelope-encryption)
9.	[Creating an SSL certificate for encryption in transit](./ssl-cert)
10.	[Configuring a web application firewall](./waf)
11.	[Replicating the data lake for disaster recovery](./dr)
